/*
  128x64 I2C OLED Display | Mete Hoca PandaShield Core

  Mete Hoca, May 2023, https://www.tindie.com/stores/metehoca/
*/
 
#include "SPI.h"
#include "Wire.h"
#include "Adafruit_SSD1306.h" // Adafruit's SSD1306 library
 
int screen_x = 128;
int screen_y = 64;
int address = 0x3C;
 
Adafruit_SSD1306 display(screen_x, screen_y, &Wire);
 
void setup() {
  display.begin(SSD1306_SWITCHCAPVCC, address);
}
 
void loop() {
  display.clearDisplay();
  display.display();
  delay(500);
  text_display("METE HOCA", 10, 24);
  delay(500);
 
  display.drawLine(0, 0, 127, 0, SSD1306_WHITE);
  display.display();
  delay(500);
  display.drawLine(127, 0, 127, 63, SSD1306_WHITE);
  display.display();
  delay(500);
  display.drawLine(127, 63, 0, 63, SSD1306_WHITE);
  display.display();
  delay(500);
  display.drawLine(0, 63, 0, 0, SSD1306_WHITE);
  display.display();
  delay(500);
 
  display.invertDisplay(true);
  delay(500);
  display.invertDisplay(false);
  delay(500);
  display.invertDisplay(true);
  delay(500);
  display.invertDisplay(false);
  delay(500);
 
  display.clearDisplay();
  display.display();
  delay(500);
  display.drawRect(0, 0, 128, 64, SSD1306_WHITE);
  display.display();
  delay(500);
 
  display.clearDisplay();
  display.display();
  delay(500);
  display.drawRoundRect(0, 0, 128, 64, 8, SSD1306_WHITE);
  display.display();
  delay(500);
 
  display.clearDisplay();
  display.display();
  delay(500);
  display.drawCircle(16, 30, 6, SSD1306_WHITE);
  display.drawCircle(39, 30, 15, SSD1306_WHITE);
  display.drawCircle(87, 30, 30, SSD1306_WHITE);
  display.display();
  delay(500);
 
  scroll_text();
}
 
void text_display(String text, int cx, int cy) {
  display.setTextSize(2);
  display.setTextColor(SSD1306_WHITE);
  display.setCursor(cx, cy);
  display.println(text);
  display.display();
}
 
void scroll_text(void) {
  display.clearDisplay();
  delay(500);
  display.setTextSize(2);
  display.setTextColor(SSD1306_WHITE);
  display.setCursor(10, 24);
  display.println("METE HOCA");
  display.display();
  delay(500);
 
  display.startscrollright(0x00, 0x0F);
  delay(2000);
  display.stopscroll();
  delay(500);
  display.startscrollleft(0x00, 0x0F);
  delay(2000);
  display.stopscroll();
  delay(500);
  display.startscrolldiagright(0x00, 0x07);
  delay(2000);
  display.startscrolldiagleft(0x00, 0x07);
  delay(2000);
  display.stopscroll();
  delay(500);
}
